package com.chinaitop.depot.intelligent.basicdata.model;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TDevDataExample {
    /**
     * t_dev_data
     */
    protected String orderByClause;

    /**
     * t_dev_data
     */
    protected boolean distinct;

    /**
     * t_dev_data
     */
    protected List<Criteria> oredCriteria;

    public TDevDataExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_dev_data 2018-12-12
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andVdevcodeIsNull() {
            addCriterion("vDevCode is null");
            return (Criteria) this;
        }

        public Criteria andVdevcodeIsNotNull() {
            addCriterion("vDevCode is not null");
            return (Criteria) this;
        }

        public Criteria andVdevcodeEqualTo(String value) {
            addCriterion("vDevCode =", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotEqualTo(String value) {
            addCriterion("vDevCode <>", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeGreaterThan(String value) {
            addCriterion("vDevCode >", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vDevCode >=", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeLessThan(String value) {
            addCriterion("vDevCode <", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeLessThanOrEqualTo(String value) {
            addCriterion("vDevCode <=", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeLike(String value) {
            addCriterion("vDevCode like", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotLike(String value) {
            addCriterion("vDevCode not like", value, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeIn(List<String> values) {
            addCriterion("vDevCode in", values, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotIn(List<String> values) {
            addCriterion("vDevCode not in", values, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeBetween(String value1, String value2) {
            addCriterion("vDevCode between", value1, value2, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevcodeNotBetween(String value1, String value2) {
            addCriterion("vDevCode not between", value1, value2, "vdevcode");
            return (Criteria) this;
        }

        public Criteria andVdevnameIsNull() {
            addCriterion("vDevName is null");
            return (Criteria) this;
        }

        public Criteria andVdevnameIsNotNull() {
            addCriterion("vDevName is not null");
            return (Criteria) this;
        }

        public Criteria andVdevnameEqualTo(String value) {
            addCriterion("vDevName =", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameNotEqualTo(String value) {
            addCriterion("vDevName <>", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameGreaterThan(String value) {
            addCriterion("vDevName >", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameGreaterThanOrEqualTo(String value) {
            addCriterion("vDevName >=", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameLessThan(String value) {
            addCriterion("vDevName <", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameLessThanOrEqualTo(String value) {
            addCriterion("vDevName <=", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameLike(String value) {
            addCriterion("vDevName like", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameNotLike(String value) {
            addCriterion("vDevName not like", value, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameIn(List<String> values) {
            addCriterion("vDevName in", values, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameNotIn(List<String> values) {
            addCriterion("vDevName not in", values, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameBetween(String value1, String value2) {
            addCriterion("vDevName between", value1, value2, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevnameNotBetween(String value1, String value2) {
            addCriterion("vDevName not between", value1, value2, "vdevname");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeIsNull() {
            addCriterion("vDevKindCode is null");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeIsNotNull() {
            addCriterion("vDevKindCode is not null");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeEqualTo(String value) {
            addCriterion("vDevKindCode =", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotEqualTo(String value) {
            addCriterion("vDevKindCode <>", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeGreaterThan(String value) {
            addCriterion("vDevKindCode >", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vDevKindCode >=", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeLessThan(String value) {
            addCriterion("vDevKindCode <", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeLessThanOrEqualTo(String value) {
            addCriterion("vDevKindCode <=", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeLike(String value) {
            addCriterion("vDevKindCode like", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotLike(String value) {
            addCriterion("vDevKindCode not like", value, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeIn(List<String> values) {
            addCriterion("vDevKindCode in", values, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotIn(List<String> values) {
            addCriterion("vDevKindCode not in", values, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeBetween(String value1, String value2) {
            addCriterion("vDevKindCode between", value1, value2, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVdevkindcodeNotBetween(String value1, String value2) {
            addCriterion("vDevKindCode not between", value1, value2, "vdevkindcode");
            return (Criteria) this;
        }

        public Criteria andVunitIsNull() {
            addCriterion("vUnit is null");
            return (Criteria) this;
        }

        public Criteria andVunitIsNotNull() {
            addCriterion("vUnit is not null");
            return (Criteria) this;
        }

        public Criteria andVunitEqualTo(String value) {
            addCriterion("vUnit =", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitNotEqualTo(String value) {
            addCriterion("vUnit <>", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitGreaterThan(String value) {
            addCriterion("vUnit >", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitGreaterThanOrEqualTo(String value) {
            addCriterion("vUnit >=", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitLessThan(String value) {
            addCriterion("vUnit <", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitLessThanOrEqualTo(String value) {
            addCriterion("vUnit <=", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitLike(String value) {
            addCriterion("vUnit like", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitNotLike(String value) {
            addCriterion("vUnit not like", value, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitIn(List<String> values) {
            addCriterion("vUnit in", values, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitNotIn(List<String> values) {
            addCriterion("vUnit not in", values, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitBetween(String value1, String value2) {
            addCriterion("vUnit between", value1, value2, "vunit");
            return (Criteria) this;
        }

        public Criteria andVunitNotBetween(String value1, String value2) {
            addCriterion("vUnit not between", value1, value2, "vunit");
            return (Criteria) this;
        }

        public Criteria andFaddvalueIsNull() {
            addCriterion("fAddValue is null");
            return (Criteria) this;
        }

        public Criteria andFaddvalueIsNotNull() {
            addCriterion("fAddValue is not null");
            return (Criteria) this;
        }

        public Criteria andFaddvalueEqualTo(Integer value) {
            addCriterion("fAddValue =", value, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueNotEqualTo(Integer value) {
            addCriterion("fAddValue <>", value, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueGreaterThan(Integer value) {
            addCriterion("fAddValue >", value, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueGreaterThanOrEqualTo(Integer value) {
            addCriterion("fAddValue >=", value, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueLessThan(Integer value) {
            addCriterion("fAddValue <", value, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueLessThanOrEqualTo(Integer value) {
            addCriterion("fAddValue <=", value, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueIn(List<Integer> values) {
            addCriterion("fAddValue in", values, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueNotIn(List<Integer> values) {
            addCriterion("fAddValue not in", values, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueBetween(Integer value1, Integer value2) {
            addCriterion("fAddValue between", value1, value2, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andFaddvalueNotBetween(Integer value1, Integer value2) {
            addCriterion("fAddValue not between", value1, value2, "faddvalue");
            return (Criteria) this;
        }

        public Criteria andVinOutIsNull() {
            addCriterion("vIn_Out is null");
            return (Criteria) this;
        }

        public Criteria andVinOutIsNotNull() {
            addCriterion("vIn_Out is not null");
            return (Criteria) this;
        }

        public Criteria andVinOutEqualTo(Integer value) {
            addCriterion("vIn_Out =", value, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutNotEqualTo(Integer value) {
            addCriterion("vIn_Out <>", value, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutGreaterThan(Integer value) {
            addCriterion("vIn_Out >", value, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutGreaterThanOrEqualTo(Integer value) {
            addCriterion("vIn_Out >=", value, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutLessThan(Integer value) {
            addCriterion("vIn_Out <", value, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutLessThanOrEqualTo(Integer value) {
            addCriterion("vIn_Out <=", value, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutIn(List<Integer> values) {
            addCriterion("vIn_Out in", values, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutNotIn(List<Integer> values) {
            addCriterion("vIn_Out not in", values, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutBetween(Integer value1, Integer value2) {
            addCriterion("vIn_Out between", value1, value2, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVinOutNotBetween(Integer value1, Integer value2) {
            addCriterion("vIn_Out not between", value1, value2, "vinOut");
            return (Criteria) this;
        }

        public Criteria andVzdcodeIsNull() {
            addCriterion("vZdCode is null");
            return (Criteria) this;
        }

        public Criteria andVzdcodeIsNotNull() {
            addCriterion("vZdCode is not null");
            return (Criteria) this;
        }

        public Criteria andVzdcodeEqualTo(String value) {
            addCriterion("vZdCode =", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeNotEqualTo(String value) {
            addCriterion("vZdCode <>", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeGreaterThan(String value) {
            addCriterion("vZdCode >", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vZdCode >=", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeLessThan(String value) {
            addCriterion("vZdCode <", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeLessThanOrEqualTo(String value) {
            addCriterion("vZdCode <=", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeLike(String value) {
            addCriterion("vZdCode like", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeNotLike(String value) {
            addCriterion("vZdCode not like", value, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeIn(List<String> values) {
            addCriterion("vZdCode in", values, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeNotIn(List<String> values) {
            addCriterion("vZdCode not in", values, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeBetween(String value1, String value2) {
            addCriterion("vZdCode between", value1, value2, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVzdcodeNotBetween(String value1, String value2) {
            addCriterion("vZdCode not between", value1, value2, "vzdcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeIsNull() {
            addCriterion("vCfCode is null");
            return (Criteria) this;
        }

        public Criteria andVcfcodeIsNotNull() {
            addCriterion("vCfCode is not null");
            return (Criteria) this;
        }

        public Criteria andVcfcodeEqualTo(String value) {
            addCriterion("vCfCode =", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeNotEqualTo(String value) {
            addCriterion("vCfCode <>", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeGreaterThan(String value) {
            addCriterion("vCfCode >", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeGreaterThanOrEqualTo(String value) {
            addCriterion("vCfCode >=", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeLessThan(String value) {
            addCriterion("vCfCode <", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeLessThanOrEqualTo(String value) {
            addCriterion("vCfCode <=", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeLike(String value) {
            addCriterion("vCfCode like", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeNotLike(String value) {
            addCriterion("vCfCode not like", value, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeIn(List<String> values) {
            addCriterion("vCfCode in", values, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeNotIn(List<String> values) {
            addCriterion("vCfCode not in", values, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeBetween(String value1, String value2) {
            addCriterion("vCfCode between", value1, value2, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVcfcodeNotBetween(String value1, String value2) {
            addCriterion("vCfCode not between", value1, value2, "vcfcode");
            return (Criteria) this;
        }

        public Criteria andVdevxhIsNull() {
            addCriterion("vDevXh is null");
            return (Criteria) this;
        }

        public Criteria andVdevxhIsNotNull() {
            addCriterion("vDevXh is not null");
            return (Criteria) this;
        }

        public Criteria andVdevxhEqualTo(String value) {
            addCriterion("vDevXh =", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhNotEqualTo(String value) {
            addCriterion("vDevXh <>", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhGreaterThan(String value) {
            addCriterion("vDevXh >", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhGreaterThanOrEqualTo(String value) {
            addCriterion("vDevXh >=", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhLessThan(String value) {
            addCriterion("vDevXh <", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhLessThanOrEqualTo(String value) {
            addCriterion("vDevXh <=", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhLike(String value) {
            addCriterion("vDevXh like", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhNotLike(String value) {
            addCriterion("vDevXh not like", value, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhIn(List<String> values) {
            addCriterion("vDevXh in", values, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhNotIn(List<String> values) {
            addCriterion("vDevXh not in", values, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhBetween(String value1, String value2) {
            addCriterion("vDevXh between", value1, value2, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andVdevxhNotBetween(String value1, String value2) {
            addCriterion("vDevXh not between", value1, value2, "vdevxh");
            return (Criteria) this;
        }

        public Criteria andFvalueIsNull() {
            addCriterion("fValue is null");
            return (Criteria) this;
        }

        public Criteria andFvalueIsNotNull() {
            addCriterion("fValue is not null");
            return (Criteria) this;
        }

        public Criteria andFvalueEqualTo(Integer value) {
            addCriterion("fValue =", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueNotEqualTo(Integer value) {
            addCriterion("fValue <>", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueGreaterThan(Integer value) {
            addCriterion("fValue >", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueGreaterThanOrEqualTo(Integer value) {
            addCriterion("fValue >=", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueLessThan(Integer value) {
            addCriterion("fValue <", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueLessThanOrEqualTo(Integer value) {
            addCriterion("fValue <=", value, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueIn(List<Integer> values) {
            addCriterion("fValue in", values, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueNotIn(List<Integer> values) {
            addCriterion("fValue not in", values, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueBetween(Integer value1, Integer value2) {
            addCriterion("fValue between", value1, value2, "fvalue");
            return (Criteria) this;
        }

        public Criteria andFvalueNotBetween(Integer value1, Integer value2) {
            addCriterion("fValue not between", value1, value2, "fvalue");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeIsNull() {
            addCriterion("vValueTime is null");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeIsNotNull() {
            addCriterion("vValueTime is not null");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeEqualTo(Date value) {
            addCriterion("vValueTime =", value, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeNotEqualTo(Date value) {
            addCriterion("vValueTime <>", value, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeGreaterThan(Date value) {
            addCriterion("vValueTime >", value, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("vValueTime >=", value, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeLessThan(Date value) {
            addCriterion("vValueTime <", value, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeLessThanOrEqualTo(Date value) {
            addCriterion("vValueTime <=", value, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeIn(List<Date> values) {
            addCriterion("vValueTime in", values, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeNotIn(List<Date> values) {
            addCriterion("vValueTime not in", values, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeBetween(Date value1, Date value2) {
            addCriterion("vValueTime between", value1, value2, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVvaluetimeNotBetween(Date value1, Date value2) {
            addCriterion("vValueTime not between", value1, value2, "vvaluetime");
            return (Criteria) this;
        }

        public Criteria andVstatueIsNull() {
            addCriterion("vStatue is null");
            return (Criteria) this;
        }

        public Criteria andVstatueIsNotNull() {
            addCriterion("vStatue is not null");
            return (Criteria) this;
        }

        public Criteria andVstatueEqualTo(Integer value) {
            addCriterion("vStatue =", value, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueNotEqualTo(Integer value) {
            addCriterion("vStatue <>", value, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueGreaterThan(Integer value) {
            addCriterion("vStatue >", value, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueGreaterThanOrEqualTo(Integer value) {
            addCriterion("vStatue >=", value, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueLessThan(Integer value) {
            addCriterion("vStatue <", value, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueLessThanOrEqualTo(Integer value) {
            addCriterion("vStatue <=", value, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueIn(List<Integer> values) {
            addCriterion("vStatue in", values, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueNotIn(List<Integer> values) {
            addCriterion("vStatue not in", values, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueBetween(Integer value1, Integer value2) {
            addCriterion("vStatue between", value1, value2, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVstatueNotBetween(Integer value1, Integer value2) {
            addCriterion("vStatue not between", value1, value2, "vstatue");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeIsNull() {
            addCriterion("vUpdatetime is null");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeIsNotNull() {
            addCriterion("vUpdatetime is not null");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeEqualTo(Date value) {
            addCriterion("vUpdatetime =", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeNotEqualTo(Date value) {
            addCriterion("vUpdatetime <>", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeGreaterThan(Date value) {
            addCriterion("vUpdatetime >", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("vUpdatetime >=", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeLessThan(Date value) {
            addCriterion("vUpdatetime <", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeLessThanOrEqualTo(Date value) {
            addCriterion("vUpdatetime <=", value, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeIn(List<Date> values) {
            addCriterion("vUpdatetime in", values, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeNotIn(List<Date> values) {
            addCriterion("vUpdatetime not in", values, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeBetween(Date value1, Date value2) {
            addCriterion("vUpdatetime between", value1, value2, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVupdatetimeNotBetween(Date value1, Date value2) {
            addCriterion("vUpdatetime not between", value1, value2, "vupdatetime");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNull() {
            addCriterion("vRemark is null");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNotNull() {
            addCriterion("vRemark is not null");
            return (Criteria) this;
        }

        public Criteria andVremarkEqualTo(String value) {
            addCriterion("vRemark =", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotEqualTo(String value) {
            addCriterion("vRemark <>", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThan(String value) {
            addCriterion("vRemark >", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThanOrEqualTo(String value) {
            addCriterion("vRemark >=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThan(String value) {
            addCriterion("vRemark <", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThanOrEqualTo(String value) {
            addCriterion("vRemark <=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLike(String value) {
            addCriterion("vRemark like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotLike(String value) {
            addCriterion("vRemark not like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkIn(List<String> values) {
            addCriterion("vRemark in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotIn(List<String> values) {
            addCriterion("vRemark not in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkBetween(String value1, String value2) {
            addCriterion("vRemark between", value1, value2, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotBetween(String value1, String value2) {
            addCriterion("vRemark not between", value1, value2, "vremark");
            return (Criteria) this;
        }
    }

    /**
     * t_dev_data
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_dev_data 2018-12-12
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}